#############################################################################
#
# $Id: VISPUse.cmake.in 3814 2012-06-26 16:26:16Z fspindle $
#
# This file is part of the ViSP software.
# Copyright (C) 2005 - 2010 by INRIA. All rights reserved.
# 
# This software is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# ("GPL") version 2 as published by the Free Software Foundation.
# See the file LICENSE.txt at the root directory of this source
# distribution for additional information about the GNU GPL.
#
# For using ViSP with software that can not be combined with the GNU
# GPL, please contact INRIA about acquiring a ViSP Professional 
# Edition License.
#
# See http://www.irisa.fr/lagadic/visp/visp.html for more information.
# 
# This software was developed at:
# INRIA Rennes - Bretagne Atlantique
# Campus Universitaire de Beaulieu
# 35042 Rennes Cedex
# France
# http://www.irisa.fr/lagadic
#
# If you have questions regarding the use of this file, please contact
# INRIA at visp@inria.fr
# 
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
# Description:
# cmake PackageConfig file.
#
# Authors:
# Fabien Spindler
#
#############################################################################

# Add extra build flags to be able to consider especially for OpenMP
list(APPEND CMAKE_CXX_FLAGS "-fopenmp")
list(APPEND CMAKE_CXX_FLAGS "")

# Remove duplicates compilation flags
separate_arguments(CMAKE_CXX_FLAGS)
list(REMOVE_DUPLICATES CMAKE_CXX_FLAGS)
string(REPLACE ";" " " CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}" CACHE STRING "common C++ build flags" FORCE)

# Tell the compiler where to find ViSP's header files
# and the third party headers we depend on
INCLUDE_DIRECTORIES(${VISP_INCLUDE_DIRS})

# Add the required definitions
ADD_DEFINITIONS(${VISP_DEFINITIONS}) 

# Tell the compiler where to find ViSP's libraries
# and the third party libraries we depend on
LINK_DIRECTORIES(${VISP_LIBRARY_DIRS})

LINK_LIBRARIES(${VISP_LIBRARIES})

